﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.ui.Keyboard;

	import org.papervision3d.scenes.*;
	import org.papervision3d.objects.*;
	import org.papervision3d.cameras.*;
	import org.papervision3d.materials.*;
	import org.papervision3d.core.Matrix3D;

	public class SharpHair extends Sprite {
		// _______________________________________________________________________
		//                                                                  vars3D
		private var container  : Sprite;
		private var scene      : Scene3D;
		private var camera     : Camera3D;
		private var boy        : Collada2;
		private var keyRight   : Boolean = false;
		private var keyLeft    : Boolean = false;
		private var keyForward : Boolean = false;
		private var keyBackward: Boolean = false;
		private var rotate:Number = 0;
		[Embed(source="SharpHair.dae", mimeType="application/octet-stream")] private var collada_boy:Class;

		// _______________________________________________________________________
		//                                                             Constructor
		public function SharpHair():void {
			stage.frameRate = 30;
			stage.quality   = "MEDIUM";
			stage.scaleMode = "noScale";
			stage.align = StageAlign.TOP_LEFT;

			init3D();

			this.addEventListener(Event.ENTER_FRAME, loop3D);
			this.stage.addEventListener(Event.RESIZE, onStageResize);
			stage.addEventListener( KeyboardEvent.KEY_DOWN, keyDownHandler );
			stage.addEventListener( KeyboardEvent.KEY_UP, keyUpHandler );
		}

		// _______________________________________________________________________
		//                                                                  Init3D
		private function init3D():void {
			//コンテナ生成
			this.container = new Sprite();
			addChild(this.container);
			this.container.x = this.stage.stageWidth  / 2;
			this.container.y = this.stage.stageHeight / 2;

			//シーン生成
			scene = new Scene3D( container );

			//カメラ設定
			camera = new Camera3D();
			camera.target.y = 150;
			camera.focus = 500;
			camera.zoom = 2;

			//Colladaオブジェクトの読み込み
			boy = new Collada2(XML( new collada_boy() ));
			scene.addChild( boy );
		}

		// _______________________________________________________________________
		//                                                                    Loop
		private function loop3D( event:Event ):void {
			camera.x = 200;
			camera.y = 400;
			camera.z = 1000;
			camera.target.x = 0;
			camera.target.y = 200;
			camera.target.z = 0;

			updateBoy();
	
			//レンダリング
			this.scene.renderCamera( camera );
		}

		private function updateBoy():void {
			if ( keyLeft ) {
				boy.rotationY -= 10;
			}
			if ( keyRight ) {
				boy.rotationY += 10;
			}
			if ( boy.rotationY < 0 ) {
				boy.rotationY += 360;
			}
			if ( boy.rotationY >= 360 ) {
				boy.rotationY -= 360;
			}

			if ( keyForward ) {
				boy.moveForward( 10 );
			}
			if ( keyBackward ) {
				boy.moveForward( -10 );
			}
		}

		// ___________________________________________________________________ Keyboard
		private function keyDownHandler( event :KeyboardEvent ):void {
			switch ( event.keyCode ) {
				case "W".charCodeAt() :
				case Keyboard.UP :
					keyForward = true;
					keyBackward = false;
					break;

				case "S".charCodeAt() :
				case Keyboard.DOWN :
					keyBackward = true;
					keyForward = false;
					break;

				case "A".charCodeAt() :
				case Keyboard.LEFT :
					keyLeft = true;
					keyRight = false;
					break;

				case "D".charCodeAt() :
				case Keyboard.RIGHT :
					keyRight = true;
					keyLeft = false;
					break;
			}
			//trace("keyDownHandler: " + event.keyCode);
		}

		private function keyUpHandler( event :KeyboardEvent ):void {
			switch ( event.keyCode ) {
				case "W".charCodeAt() :
				case Keyboard.UP :
					keyForward = false;
					break;

				case "S".charCodeAt() :
				case Keyboard.DOWN :
					keyBackward = false;
					break;

				case "A".charCodeAt() :
				case Keyboard.LEFT :
					keyLeft = false;
					break;

				case "D".charCodeAt() :
				case Keyboard.RIGHT :
					keyRight = false;
					break;
			}
			//trace("keyUpHandler: " + event.keyCode);
		}

		// _______________________________________________________________________
		//                                                           onStageResize
		private function onStageResize(event:Event):void {
			this.container.x = this.stage.stageWidth  / 2;
			this.container.y = this.stage.stageHeight / 2;
		}
	}
}